class BlocksTailGroup implements Shape {
  int minXSize, minYSize, maxXSize, maxYSize;

  //Blocks
  BlocksTailGroup() {
  } //Blocks

  //updateDraw
  @Override
    void updateDraw(int dOriginX, int dOriginY, int dWidth, int dHeight, PGraphics buffer) {

    buffer.pushMatrix();
    buffer.translate(dOriginX, dOriginY);

      if (showRects) {
        buffer.fill(255, 255, 0);
        buffer.stroke(0);
        buffer.rect(0, 0, dWidth, dHeight);
      }

      //determine how many can really fit
      float area = dWidth * dHeight;
      int targetBlocksCount = int(area / 9000.0);

      for (int i=0; i<targetBlocksCount; i++) {
        BlocksTail t = new BlocksTail();
        t.setSizes(50, 40, 150, 90);

        int ww = int(random(t.maxXSize() - t.minXSize())) + t.minXSize();
        int hh = int(random(t.maxYSize() - t.minYSize)) + t.minYSize();
        int yyo = int(random(dHeight - t.maxYSize()));
        int xxo = max(int(random(dWidth - t.maxXSize())),0);

        t.updateDraw(xxo, yyo, ww, hh, buffer);
      }

      buffer.strokeWeight(1);


      buffer.popMatrix();
  } //updateDraw

  void setSizes(int minX, int minY, int maxX, int maxY) {
    minXSize = minX;
    minYSize = minY;
    maxXSize = maxX;
    maxYSize = maxY;
  }
  int minXSize() {
    return minXSize;
  }
  int minYSize() {
    return minYSize;
  }
  int maxXSize() {
    return maxXSize;
  }
  int maxYSize() {
    return maxYSize;
  }
}

