//! normalized art size for comb, but not for dot swish?


class BufferArea {

  PGraphics buffer;
  PImage displayImage;
  float scrollPosition;
  int bufferWidth, bufferHeight;
  boolean displayScore;
  Shape sh;

  BufferArea(int w, int h, float s) {
    bufferWidth = w;
    bufferHeight = h;
    buffer = createGraphics(bufferWidth, bufferHeight, JAVA2D);
    scrollPosition = s;
    displayScore = false;

    update();
  }

  void update() {

    //we just set displayImage when it's in score mode, no need to calculate
    if (!displayScore) {
      buffer.beginDraw();
      if (showRandBufferBackground) {
        buffer.background(int(random(255)), int(random(255)), int(random(255)));
      }      
      else {
        buffer.background(bgColor);
      }
      buffer.smooth();

      int objectsAdded = 0;

      int startingY = int(random(bufferHeight));
      startingY = max(startingY, 30);
      startingY = min(startingY, bufferHeight-30);

      if (random(1) < 0.5 &&
      bufferWidth > 160) {
        addReverbBlob(5, startingY);
      }

      objectsAdded = addShapes(0, startingY);

      if (objectsAdded == 0) {
        buffer.background(bgColor);
      }

      buffer.tint(255, 75);
      buffer.image(textureImage, 0, 0);
      buffer.tint(255);

      buffer.endDraw();

      displayImage = buffer.get();
    }
  }

  void addReverbBlob(int startingX, int startingY) {
    if (bufferWidth > 120) {
      buffer.noStroke();
      buffer.fill(236, 227, 221);
      PVector ul, ur, ll, lr;
      float md = bufferWidth * 0.1;
      ul = new PVector(random(50) + md, random((bufferHeight - md) / 2.0) + md);
      ur = new PVector(bufferWidth - (random(50) + md), random((bufferHeight - md) / 2.0) + md);
      ll = new PVector(random(50) + md, bufferHeight - (random((bufferHeight - md) / 2.0) + md));
      lr = new PVector(bufferWidth - (random(50) + md), bufferHeight - (random((bufferHeight - md) / 2.0) + md));

      if (ul.x > ur.x - 60) {
        ur.x = ul.x + 60;
      }
      if (ll.x > lr.x - 60) {
        lr.x = ll.x + 60;
      }
      if (ur.y > lr.y - 60) {
        lr.y = ur.y + 60;
      }
      if (ul.y > ll.y - 60) {
        ll.y = ul.y + 60;
      }

      buffer.beginShape();
      buffer.curveVertex(ur.x, ur.y);
      buffer.curveVertex(ul.x, ul.y);
      buffer.curveVertex(ll.x, ll.y);
      buffer.curveVertex(lr.x, lr.y);
      buffer.curveVertex(ur.x, ur.y);
      buffer.curveVertex(ul.x, ul.y);
      buffer.curveVertex(ll.x, ll.y);
      buffer.endShape();

      //buffer.noStroke();
      //buffer.fill(255,0,0);
      //buffer.ellipse(ul.x,ul.y,5,5);
      //buffer.ellipse(ur.x,ur.y,5,5);
      //buffer.ellipse(ll.x,ll.y,5,5);
      //buffer.ellipse(lr.x,lr.y,5,5);
    }
  }

  int addShapes(int startingX, int startingY) {

    Shape sh, lowerShape, upperShape;

    sh = getMainShape();
    lowerShape = getLowerShape();
    upperShape = getUpperShape();

    int objectsAdded = 0;
    int xo, yo, w, h;
    xo = startingX;
    yo = startingY;


    w = int(random(sh.maxXSize() - sh.minXSize())) + sh.minXSize();
    h = int(random(sh.maxYSize() - sh.minYSize())) + sh.minYSize();

    //hacky:
//    println("maxX == "+sh.maxXSize());
    if (sh.maxXSize() > 400) { //catch blockGroups
//      println("it's a block group!");
      w = min(bufferWidth - xo, w);
    } 

    if (xo + w > bufferWidth) {
//      println("returning! too wide!");
      return 0;
    }
    while (yo + h > bufferHeight) {
      yo -= (yo + h) - bufferHeight + 1;
//      println("yo is now: "+yo+" h is: "+h);
    }
    buffer.stroke(255, 0, 0);
    buffer.fill(120, 54, 0);

    sh.updateDraw(xo, yo, w, h, buffer);
    objectsAdded++;

    while (true) {
      sh = getMainShape();

      //hacky:
      //      while (sh.maxXSize () > bufferWidth) { //catch BlocksTailGroup
      //        sh = getMainShape();
      //      }
      xo += w;
      yo += int(random(bufferHeight / 4)) - (bufferHeight / 8);
      w = int(random(sh.maxXSize() - sh.minXSize())) + sh.minXSize();
      h = int(random(sh.maxYSize() - sh.minYSize())) + sh.minYSize();

    if (sh.maxXSize() > 400) { //catch blockGroups
//      println("it's a block group inside the other loop!");
      w = min(bufferWidth - xo, w);
      
      if (w < 50) break;
    } 
    
      if (xo + w > bufferWidth) {
//        println("breaking! too wide!");
        break;
      }
      while (yo + h > bufferHeight) {
        yo -= h;
      }
      while (yo < 0) {
        yo += h;
      }

      sh.updateDraw(xo, yo, w, h, buffer);

      float coinFlip = random(1);
      if (coinFlip > 0.33) {
        fill(255, 255, 0);
        int yyo = yo + h + int(random(lowerShape.minYSize()));
        int xxo = xo + int(random(w - lowerShape.minXSize()));
        int ww = int(random(lowerShape.maxXSize() - lowerShape.minXSize())) + lowerShape.minXSize();
        int hh = int(random(lowerShape.maxYSize() - lowerShape.minYSize())) + lowerShape.minYSize();
        if (yyo + hh < bufferHeight &&
          xxo + ww < bufferWidth) {
          lowerShape.updateDraw(xxo, yyo, ww, hh, buffer);
        }
      }
      coinFlip = random(1);
      if (coinFlip > 0.33) {
        fill(255, 255, 0);

        int prevHH = 0;
        for (int i=0; i<2; i++) {
          int ww = int(random(upperShape.maxXSize() - upperShape.minXSize())) + upperShape.minXSize();
          int hh = int(random(upperShape.maxYSize() - upperShape.minYSize())) + upperShape.minYSize();
          int yyo = yo - (hh + prevHH) - int(random(upperShape.minYSize()));
          int xxo = xo + int(random(float(w) - upperShape.minXSize()));

          if (yyo > 0 &&
            xxo + ww < bufferWidth) {
            upperShape.updateDraw(xxo, yyo, ww, hh, buffer);
          }

          prevHH = hh;
        }
      }
      objectsAdded++;
    }

    return objectsAdded;
  }
}

