class Comb implements Shape {
  color dColor;
  int dTeeth;
  boolean dClosed;
  int minXSize, minYSize, maxXSize, maxYSize;

  //Comb
  Comb() {
    //defaults
    dTeeth = 5;
    dClosed = false;
  } //Comb

  //updateDraw
  @Override
    void updateDraw(int dOriginX, int dOriginY, int dWidth, int dHeight, PGraphics buffer) {
    dColor = getCombColor();

    buffer.pushMatrix();
    buffer.translate(dOriginX, dOriginY);

    if (showRects) {
      buffer.fill(120, 80, 0);
      buffer.noStroke();
      buffer.rect(0, 0, dWidth, dHeight);
    }

    buffer.fill(dColor);
    buffer.noStroke();

    float leftWidth = min(20, float(dWidth) / 6.0);
    leftWidth = max(leftWidth, 8);
    buffer.rect(0, 0, leftWidth, dHeight);

    dTeeth = int(random(5)) + 5;

    float toothYDivision = float(dHeight) / float(dTeeth);
    float toothHeight = toothYDivision * 0.6;
    float makeupWidth = (toothYDivision * 0.4) / (dTeeth - 1);
    float toothYPos = 0.0;

    //normal
    int slope = int(random(3));
    for (int i=0; i<dTeeth; i++) {
      toothYPos = toothYDivision * i + (makeupWidth * i);
      //        rect(0, toothYPos, dWidth, toothHeight);

      buffer.strokeWeight(toothHeight);
      buffer.noFill();
      buffer.stroke(dColor);

      if (dWidth > 25) {
        switch(slope) {
        case 0:
          {
            buffer.bezier(
            0 + (toothHeight / 2.0), 
            toothYPos + (toothHeight / 2.0) - 1, 
            dWidth - (toothHeight * 2), 
            toothYPos + (toothHeight / 2.0), 
            dWidth - (toothHeight / 2.0), 
            toothYPos + (toothHeight / 2.0) + (dHeight / 3.0), 
            dWidth - (toothHeight / 2.0), 
            toothYPos + (toothHeight / 2.0) + (dHeight / 3.0));
          } 
          break;
        case 1:
          {
            buffer.bezier(
            0 + (toothHeight / 2.0), 
            toothYPos + (toothHeight / 2.0) - 1, 
            dWidth - (toothHeight * 2), 
            toothYPos + (toothHeight / 2.0), 
            dWidth - (toothHeight / 2.0), 
            toothYPos + (toothHeight / 2.0) - (dHeight / 3.0), 
            dWidth - (toothHeight / 2.0), 
            toothYPos + (toothHeight / 2.0) - (dHeight / 3.0));
          }
          break;
        case 2:
          {
            buffer.line(0 + (toothHeight / 2.0), toothYPos + (toothHeight / 2.0), dWidth - (toothHeight / 2.0), toothYPos + (toothHeight / 2.0));
          }
          break;
        default:
          break;
        }
      }
      else {
        buffer.line(0 + (toothHeight / 2.0), toothYPos + (toothHeight / 2.0), dWidth - (toothHeight / 2.0), toothYPos + (toothHeight / 2.0));
      }

      //      buffer.line(
      //      0 + (toothHeight / 2.0), 
      //      toothYPos + (toothHeight / 2.0), 
      //      dWidth - (toothHeight / 2.0), 
      //      toothYPos + (toothHeight / 2.0));
      buffer.strokeWeight(1);
    }
    strokeWeight(1);

    if (dClosed) {
      buffer.noStroke();
      buffer.fill(dColor);
      buffer.rect(dWidth - leftWidth, 0, leftWidth + 1, dHeight);
    }

    buffer.popMatrix();
  } //updateDraw

  void setSizes(int minX, int minY, int maxX, int maxY) {
    minXSize = minX;
    minYSize = minY;
    maxXSize = maxX;
    maxYSize = maxY;
  }
  int minXSize() {
    return minXSize;
  }
  int minYSize() {
    return minYSize;
  }
  int maxXSize() {
    return maxXSize;
  }
  int maxYSize() {
    return maxYSize;
  }
}

