class DotsConnected implements Shape {
  color dColor;
  boolean dIsHollow;
  int minXSize, minYSize, maxXSize, maxYSize;

  //!hollow not allowed!

  //Dot
  DotsConnected() {
    dIsHollow = false;
  } //Dot

  //updateDraw
  @Override
    void updateDraw(int dOriginX, int dOriginY, int dWidth, int dHeight, PGraphics buffer) {
    dColor = getDotColor();

    buffer.ellipseMode(LEFT);

    buffer.pushMatrix();
    buffer.translate(dOriginX, dOriginY);

    if (showRects) {
      buffer.fill(120, 80, 0);
      buffer.stroke(0);
      buffer.rect(0, 0, dWidth, dHeight);
    }

    float ellipseTargetSize = random(8) + 12;
    int randSize = int(float(dWidth) / ellipseTargetSize);
    float dSize = float(dWidth) / float(randSize);

    buffer.fill(dColor);
    buffer.noStroke();
    float startingY = random(dHeight - dSize);
    buffer.ellipse(0, startingY, dSize, dSize);

    if (dIsHollow) {
      buffer.fill(bgColor);
      float scaler = 0.55;
      buffer.ellipse(((1.0 - scaler) / 2.0) * dSize, (((1.0 - scaler) / 2.0) * dSize) + startingY, dSize * scaler, dSize * scaler);
    } 

    float dSizeHalf = dSize / 2.0;

    PVector p = new PVector(dSizeHalf, dSizeHalf + startingY);
    for (int i=1; i<randSize-1; i++) {
      //      float ellipseDrawScaler = random(0.4) + 0.6;
      //      float dDrawSize = dSize * ellipseDrawScaler;


      float targetY = random(dHeight - dSize);
      buffer.fill(dColor);
      buffer.noStroke();
      float randXOffset = random(dSize*0.7);


      if (i * dSize + dSize + randXOffset < dWidth) {
        buffer.ellipse((i * dSize) + randXOffset, targetY, dSize, dSize);

        float dSizeOffset = 0.8 * dSize;

        PVector n = new PVector(i * dSize + dSizeHalf + randXOffset, targetY + dSizeHalf);
        float d = dist(p.x, p.y, n.x, n.y);
        float dx = (n.x-p.x);
        float dy = (n.y-p.y);

        buffer.pushMatrix();
        buffer.translate(p.x, p.y);
        buffer.noFill();
        buffer.stroke(dColor);
        buffer.strokeWeight(4);
        if (d > (2.2 * dSizeOffset)) { 
          buffer.line(dx * (dSizeOffset / d), dy * (dSizeOffset / d), n.x - p.x - (dx * (dSizeOffset / d)), n.y  - p.y - (dy * (dSizeOffset / d)));
        }
        buffer.popMatrix();
        p = n;

        buffer.strokeWeight(1);

        dIsHollow = random(1) > 0.66;
        if (dIsHollow) {
          buffer.fill(bgColor);
          buffer.noStroke();
          float scaler = 0.55;
          buffer.ellipse((i * dSize) + (((1.0 - scaler) / 2.0) * dSize) + randXOffset, targetY + (((1.0 - scaler) / 2.0) * dSize), dSize * scaler, dSize * scaler);
        }
      }
    }

    buffer.popMatrix();
  } //updateDraw

  void setSizes(int minX, int minY, int maxX, int maxY) {
    minXSize = minX;
    minYSize = minY;
    maxXSize = maxX;
    maxYSize = maxY;
  }
  int minXSize() {
    return minXSize;
  }
  int minYSize() {
    return minYSize;
  }
  int maxXSize() {
    return maxXSize;
  }
  int maxYSize() {
    return maxYSize;
  }
}

